<script>
  import PdfPage from './PdfPage.svelte';
  import { onMount } from 'svelte';

  let orbitElement;
  let pages = [];

  export let src = '';
  
  onMount(() => {
    const loadingTask = pdfjsLib.getDocument(src);
    loadingTask.promise.then(pdf => {
      const { numPages } = pdf;

      let _pages = Array.from({ length: numPages }, (_, i) => ({ promise: pdf.getPage(i+1) }));

      Promise.all(
        _pages.map(p => new Promise(resolve => { p.resolve = resolve; }))
      ).then(() => {
        const _ = new Foundation.Orbit(jQuery(orbitElement));
      });

      pages = _pages;
    });
  });
</script>

<div bind:this={orbitElement} class="orbit" role="region" aria-label="Sheet" data-auto-play="false" data-use-m-u-i="false">
  <div class="orbit-wrapper">
    <div class="orbit-controls">
      <button class="orbit-previous"><span class="show-for-sr">Previous Slide</span>&#9664;&#xFE0E;</button>
      <button class="orbit-next"><span class="show-for-sr">Next Slide</span>&#9654;&#xFE0E;</button>
    </div>
    <ul class="orbit-container">
      {#each pages as p}
        <PdfPage promise={p.promise} on:pageRenderStart="{p.resolve}"/>
      {/each}
    </ul>
  </div>
  <nav class="orbit-bullets">
    {#each pages as _, i}
      <button data-slide={i} class:is-active="{i === 0}"></button>
    {/each}
  </nav>
</div>
